# coding: utf-8

"""
    Esper Manage API

    # Introduction Esper Manage APIs for Cloud are a set of REST-based APIs that help you programmatically control and monitor your enterprise's dedicated Esper endpoint. Using these APIs, one can orchestrate & manage devices that have been provisioned against your endpoint. Furthermore, this API allows you to manage android applications that get installed on such devices. To read more about the various capabilities of Esper endpoints and Esper managed devices, please visit [esper.io](https://esper.io). This guide describes all the available APIs in detail, along with code samples for you to quickly ramp up to using them.  You can find out more about Esper at [https://esper.io](https://esper.io)  We've done our best to keep this document up to date, but if you find any issues, please reach out to us at developer@esper.io.  # SDK    You are welcome to use your favorite HTTP/REST library for your programming language in order to use these APIs, or you can use our official SDK (currently available in [python](https://github.com/esper-io/esper-client-py)) to do so.   # Authentication Client needs to send authentication details to access APIs. Following authentication schemes are supported:  #### Basic Authentication Client can use username and password to authenticate. These are your developer account credentials. For example, the client sends HTTP requests with the Authorization header that contains the word `Basic` followed by a space and a base64-encoded string `username:password`. ##### Base64 encoding Bash  ``` echo 'username:password' | base64 ```  Powershell  ``` [System.Convert]::ToBase64String([System.Text.Encoding]::UTF8.GetBytes(\"username:password\")) ```  **Example request** ```bash curl -X GET \\   https://DOMAIN.shoonyacloud.com/api/enterprise/<enterprise_id>/device/ \\   -H 'Authorization: Basic cl0ZWFkbWluOnNpdG1pbjEyMyQ=' \\   -H 'Content-Type: application/json' \\ ``` You can read more about basic authentication scheme  [here](https://swagger.io/docs/specification/authentication/basic-authentication/)  # Errors The API uses standard HTTP status codes to indicate success or failure. All error responses will have a JSON body in the following format  ``` {   \"errors\": [],   \"message\": \"error message\",   \"status\": 400 } ``` * `errors` -  List of error details * `message` - Error description * `status` - HTTP status code   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: developer@esper.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from esperclient.models.device_app_permission import DeviceAppPermission  # noqa: F401,E501


class DeviceApp(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'permissions': 'list[DeviceAppPermission]',
        'app_name': 'str',
        'package_name': 'str',
        'whitelisted': 'bool',
        'product_id': 'str',
        'version_code': 'str',
        'version_name': 'str',
        'created_on': 'datetime',
        'updated_on': 'datetime',
        'is_active': 'bool',
        'device': 'str'
    }

    attribute_map = {
        'id': 'id',
        'permissions': 'permissions',
        'app_name': 'app_name',
        'package_name': 'package_name',
        'whitelisted': 'whitelisted',
        'product_id': 'product_id',
        'version_code': 'version_code',
        'version_name': 'version_name',
        'created_on': 'created_on',
        'updated_on': 'updated_on',
        'is_active': 'is_active',
        'device': 'device'
    }

    def __init__(self, id=None, permissions=None, app_name=None, package_name=None, whitelisted=None, product_id=None, version_code=None, version_name=None, created_on=None, updated_on=None, is_active=None, device=None):  # noqa: E501
        """DeviceApp - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._permissions = None
        self._app_name = None
        self._package_name = None
        self._whitelisted = None
        self._product_id = None
        self._version_code = None
        self._version_name = None
        self._created_on = None
        self._updated_on = None
        self._is_active = None
        self._device = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if permissions is not None:
            self.permissions = permissions
        self.app_name = app_name
        self.package_name = package_name
        if whitelisted is not None:
            self.whitelisted = whitelisted
        if product_id is not None:
            self.product_id = product_id
        if version_code is not None:
            self.version_code = version_code
        if version_name is not None:
            self.version_name = version_name
        if created_on is not None:
            self.created_on = created_on
        if updated_on is not None:
            self.updated_on = updated_on
        if is_active is not None:
            self.is_active = is_active
        self.device = device

    @property
    def id(self):
        """Gets the id of this DeviceApp.  # noqa: E501


        :return: The id of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DeviceApp.


        :param id: The id of this DeviceApp.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def permissions(self):
        """Gets the permissions of this DeviceApp.  # noqa: E501


        :return: The permissions of this DeviceApp.  # noqa: E501
        :rtype: list[DeviceAppPermission]
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this DeviceApp.


        :param permissions: The permissions of this DeviceApp.  # noqa: E501
        :type: list[DeviceAppPermission]
        """

        self._permissions = permissions

    @property
    def app_name(self):
        """Gets the app_name of this DeviceApp.  # noqa: E501


        :return: The app_name of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._app_name

    @app_name.setter
    def app_name(self, app_name):
        """Sets the app_name of this DeviceApp.


        :param app_name: The app_name of this DeviceApp.  # noqa: E501
        :type: str
        """
        if app_name is None:
            raise ValueError("Invalid value for `app_name`, must not be `None`")  # noqa: E501
        if app_name is not None and len(app_name) < 1:
            raise ValueError("Invalid value for `app_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._app_name = app_name

    @property
    def package_name(self):
        """Gets the package_name of this DeviceApp.  # noqa: E501


        :return: The package_name of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this DeviceApp.


        :param package_name: The package_name of this DeviceApp.  # noqa: E501
        :type: str
        """
        if package_name is None:
            raise ValueError("Invalid value for `package_name`, must not be `None`")  # noqa: E501
        if package_name is not None and len(package_name) > 255:
            raise ValueError("Invalid value for `package_name`, length must be less than or equal to `255`")  # noqa: E501
        if package_name is not None and len(package_name) < 1:
            raise ValueError("Invalid value for `package_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._package_name = package_name

    @property
    def whitelisted(self):
        """Gets the whitelisted of this DeviceApp.  # noqa: E501


        :return: The whitelisted of this DeviceApp.  # noqa: E501
        :rtype: bool
        """
        return self._whitelisted

    @whitelisted.setter
    def whitelisted(self, whitelisted):
        """Sets the whitelisted of this DeviceApp.


        :param whitelisted: The whitelisted of this DeviceApp.  # noqa: E501
        :type: bool
        """

        self._whitelisted = whitelisted

    @property
    def product_id(self):
        """Gets the product_id of this DeviceApp.  # noqa: E501


        :return: The product_id of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this DeviceApp.


        :param product_id: The product_id of this DeviceApp.  # noqa: E501
        :type: str
        """
        if product_id is not None and len(product_id) > 255:
            raise ValueError("Invalid value for `product_id`, length must be less than or equal to `255`")  # noqa: E501
        if product_id is not None and len(product_id) < 1:
            raise ValueError("Invalid value for `product_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._product_id = product_id

    @property
    def version_code(self):
        """Gets the version_code of this DeviceApp.  # noqa: E501


        :return: The version_code of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._version_code

    @version_code.setter
    def version_code(self, version_code):
        """Sets the version_code of this DeviceApp.


        :param version_code: The version_code of this DeviceApp.  # noqa: E501
        :type: str
        """
        if version_code is not None and len(version_code) > 128:
            raise ValueError("Invalid value for `version_code`, length must be less than or equal to `128`")  # noqa: E501
        if version_code is not None and len(version_code) < 1:
            raise ValueError("Invalid value for `version_code`, length must be greater than or equal to `1`")  # noqa: E501

        self._version_code = version_code

    @property
    def version_name(self):
        """Gets the version_name of this DeviceApp.  # noqa: E501


        :return: The version_name of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._version_name

    @version_name.setter
    def version_name(self, version_name):
        """Sets the version_name of this DeviceApp.


        :param version_name: The version_name of this DeviceApp.  # noqa: E501
        :type: str
        """
        if version_name is not None and len(version_name) > 128:
            raise ValueError("Invalid value for `version_name`, length must be less than or equal to `128`")  # noqa: E501
        if version_name is not None and len(version_name) < 1:
            raise ValueError("Invalid value for `version_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._version_name = version_name

    @property
    def created_on(self):
        """Gets the created_on of this DeviceApp.  # noqa: E501


        :return: The created_on of this DeviceApp.  # noqa: E501
        :rtype: datetime
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this DeviceApp.


        :param created_on: The created_on of this DeviceApp.  # noqa: E501
        :type: datetime
        """

        self._created_on = created_on

    @property
    def updated_on(self):
        """Gets the updated_on of this DeviceApp.  # noqa: E501


        :return: The updated_on of this DeviceApp.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_on

    @updated_on.setter
    def updated_on(self, updated_on):
        """Sets the updated_on of this DeviceApp.


        :param updated_on: The updated_on of this DeviceApp.  # noqa: E501
        :type: datetime
        """

        self._updated_on = updated_on

    @property
    def is_active(self):
        """Gets the is_active of this DeviceApp.  # noqa: E501


        :return: The is_active of this DeviceApp.  # noqa: E501
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active):
        """Sets the is_active of this DeviceApp.


        :param is_active: The is_active of this DeviceApp.  # noqa: E501
        :type: bool
        """

        self._is_active = is_active

    @property
    def device(self):
        """Gets the device of this DeviceApp.  # noqa: E501


        :return: The device of this DeviceApp.  # noqa: E501
        :rtype: str
        """
        return self._device

    @device.setter
    def device(self, device):
        """Sets the device of this DeviceApp.


        :param device: The device of this DeviceApp.  # noqa: E501
        :type: str
        """
        if device is None:
            raise ValueError("Invalid value for `device`, must not be `None`")  # noqa: E501

        self._device = device

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeviceApp, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceApp):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
